-- Uncommented/Semi-Minified version 1.0.2-release (I know, oh, the irony...)
C_Timer.After(1, function()
    local frame = CreateFrame("Button", "LazySpecsPriorityButton", CharacterStatsPane.AttributesCategory, UIPanelButtonTemplate)
    frame:SetPoint("RIGHT", CharacterStatsPane.AttributesCategory, "RIGHT", -20, 0)
    frame:SetSize(20, 20)
    frame:SetHighlightTexture("Interface\\ICONS\\misc_arrowright.blp")
    frame:SetNormalTexture("Interface\\ICONS\\misc_arrowright.blp")
    frame.prioriName = frame:CreateFontString(nil, "ARTWORK")
    frame.prioriName:SetFont("Fonts\\FRIZQT__.TTF", 12)
    frame.prioriName:SetTextColor(120,120,0)
    frame.prioriName:SetAllPoints(true)
    frame.prioriName:SetJustifyH("CENTER")
    frame.prioriName:SetJustifyV("CENTER")
    frame.prioriName:SetText(">")
    frame:SetScript("OnClick", function(self, arg1)
        PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
        if isLazySpecsPriorityFrameHidden == 1 then
            LazySpecsPriorityFrame:Show()
            frame:SetHighlightTexture("Interface\\ICONS\\misc_arrowleft.blp")
            frame:SetNormalTexture("Interface\\ICONS\\misc_arrowleft.blp")
            isLazySpecsPriorityFrameHidden = 0
        elseif isLazySpecsPriorityFrameHidden == 0 then
            LazySpecsPriorityFrame:Hide()
            frame:SetHighlightTexture("Interface\\ICONS\\misc_arrowright.blp")
            frame:SetNormalTexture("Interface\\ICONS\\misc_arrowright.blp")
            isLazySpecsPriorityFrameHidden = 1
        end
    end)
    frame:SetScript("OnMouseDown", function(self, arg1)
        frame:SetSize(17, 17)
    end)
    frame:SetScript("OnMouseUp", function(self, arg1)
        frame:SetSize(20, 20)
    end)
    local f=CreateFrame("Frame","LazySpecsPriorityFrame", CharacterFrame)
    f:SetFrameStrata("BACKGROUND")
    f:SetHeight(427)
    f:SetWidth(200)
    f:SetPoint("TOPLEFT", CharacterFrame, "TOPRIGHT", 2, 2)
    f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background",
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
        tile = true, tileSize = 16, edgeSize = 16, 
        insets = { left = 4, right = 4, top = 4, bottom = 4 }
    })
    f:SetBackdropColor(0, 0, 0)
    f:SetPoint("CENTER")
    LazySpecsPriorityFrame:Hide()
    isLazySpecsPriorityFrameHidden = 1
    function getPlayerInfo()
        playerClass, englishClass = UnitClass("player");
        currentSpec = GetSpecialization()
        currentSpecName = currentSpec and select(2, GetSpecializationInfo(currentSpec)) or "None"
        playerClassName = playerClass
        playerSpecName = currentSpecName
    end
    getPlayerInfo()
    playableClassesDB = {'DEATHKNIGHT1','DEATHKNIGHT2','DEATHKNIGHT3','DEMONHUNTER1','DEMONHUNTER2','DRUID1','DRUID2','DRUID3','DRUID4','HUNTER1','HUNTER2','HUNTER3','MAGE1','MAGE2','MAGE3','MONK1','MONK2','MONK3','PALADIN1','PALADIN2','PALADIN3','PRIEST1','PRIEST2','PRIEST3','ROGUE1','ROGUE2','ROGUE3','SHAMAN1','SHAMAN2','SHAMAN3','WARLOCK1','WARLOCK2','WARLOCK3','WARRIOR1','WARRIOR2','WARRIOR3'}
    playableClassesSP = {
        'Haste > Versatility > Mastery > Critical Strike', 'Mastery > Critical Strike > Versatility > Haste', 'Haste > Critical Strike/Versatility > Mastery', 'Agility > Haste = Versatility > Critical Strike > Mastery', 'Agility > Haste > Versatility > Mastery > Critical Strike', 'Intellect > Haste > Critical Strike > Versatility > Mastery', 'Agility > Haste > Critical Strike > Versatility > Mastery', 'Armor/Agility/Stamina > Mastery > Versatility > Haste > Critical Strike', 'Intellect > Haste = Critical Strike = Versatility > Mastery', 'Haste > Mastery > Versatility > Critical Strike', 'Critical Strike > Mastery > Versatility > Haste', 'Haste > Critical Strike > Versatility > Mastery', 'Intellect > Critical Strike > Haste > Mastery > Versatility', 'Intellect > Mastery > Versatility > Haste > Critical Strike', 'Intellect > Critical Strike (to 33.34%) > Haste > Versatility > Mastery > Critical (after 33.34%)', 'Agility > Critical Strike = Versatility = Mastery > Haste', 'Intellect > Critical Strike > Versatility > Haste > Mastery', 'Weapon Damage > Agility > Versatility > Mastery > Critical Strike > Haste', 'Intellect > Critical Strike > Haste > Versatility > Mastery', 'Haste > Mastery > Versatility > Critical Strike', 'Strength > Haste > Critical Strike = Versatility = Mastery', 'Intellect > Haste > Critical Strike > Mastery > Versatility', 'Intellect > Mastery > Critical Strike > Haste > Versatility', 'Intellect > Haste = Critical Strike > Mastery > Versatility', 'Agility > Haste > Critical Strike > Mastery > Versatility', 'Agility > Haste > Versatility > Critical Strike > Mastery', 'Critical Strike > Haste > Mastery > Versatility', 'Intellect > Haste > Versatility > Critical Strike > Mastery', 'Agility > Haste > Critical Strike = Versatility > Mastery', 'Intellect > Critical Strike > Versatility > Haste = Mastery', 'Mastery > Intellect > Haste > Critical Strike > Versatility', 'Intellect > Haste > Critical Strike > Mastery > Versatility', 'Intellect > Haste > Critical Strike > Mastery > Versatility', 'Strength > Haste > Critical Strike > Mastery > Versatility', 'Strength > Haste > Mastery > Versatility > Critical Strike', 'Haste > Versatility >= Mastery > Critical Strike > Strength'
    }
    function refreshPriorities()
        actualClass = englishClass .. GetSpecialization()
        a = 0
        repeat
            a = a + 1
        until( string.lower(actualClass) == string.lower(playableClassesDB[a]) )
        fixedPriority1 = string.gsub(playableClassesSP[a], ">", ">\n")
        fixedPriority2 = string.gsub(fixedPriority1, "/", " =")
        playerStatPriority = string.gsub(fixedPriority2, "=", "=\n") 
    end
    refreshPriorities()
    function updatePriorityText()
        f.className:SetText(playerClassName)
        f.specName:SetText(playerSpecName)
        f.statPriority:SetText(playerStatPriority)
    end
    local frame, events = CreateFrame("Frame", "LazySpecsEventsFrame", UIParent), {};
    function events:ACTIVE_TALENT_GROUP_CHANGED(...)
        getPlayerInfo()
        refreshPriorities()
        updatePriorityText()
    end
    frame:SetScript("OnEvent", function(self, event, ...)
     events[event](self, ...);
    end);
    for k, v in pairs(events) do
     frame:RegisterEvent(k);
    end
    f.specName = f:CreateFontString(nil, "ARTWORK")
    f.specName:SetFont("Fonts\\FRIZQT__.TTF", 16)
    f.specName:SetTextColor(1, 1, 1)
    f.specName:SetPoint("TOP", LazySpecsPriorityFrame, "TOP", 0, -20, 0, 0)
    f.specName:SetJustifyH("CENTER")
    f.specName:SetJustifyV("TOP")
    f.specName:SetText(playerSpecName)
    f.className = f:CreateFontString(nil, "ARTWORK")
    f.className:SetFont("Fonts\\FRIZQT__.TTF", 16)
    f.className:SetTextColor(1, 1, 1)
    f.className:SetPoint("TOP", LazySpecsPriorityFrame, "TOP", 0, -45, 0, 0)
    f.className:SetJustifyH("CENTER")
    f.className:SetJustifyV("TOP")
    f.className:SetText(playerClassName)
    f.statPriority = f:CreateFontString(nil, "ARTWORK")
    f.statPriority:SetFont("Fonts\\FRIZQT__.TTF", 14)
    f.statPriority:SetTextColor(1, 1, 1)
    f.statPriority:SetAllPoints(true)
    f.statPriority:SetJustifyH("CENTER")
    f.statPriority:SetJustifyV("CENTER")
    f.statPriority:SetText(playerStatPriority)
end)